(
var genInitSeq, finalizeSeqs, finalizeAccompHigh, finalizeAccompLow;

//~~~~init vars for initial sequence generation
genInitSeq = {arg seed = 1004;
	var setDur, strings, stringIndex, state, lastStrings, position, dur, openStringCount, landingCount, sectionCount, res;

	thisThread.randSeed = seed;

	//~~~~helper dur function
	setDur = {[0, 2, 3, 4, 5.rand + 3].wchoose([0, 5, 5, 5, 1].normalizeSum)};

	strings = (0..5);
	//stringIndex = 0;
	state = 6.collect({[0, 1].wchoose([2, 1].normalizeSum)}); //fretted or not
	lastStrings = [nil, nil];
	position = 6.collect({10 + 3.rand}); //which frets
	dur = setDur.value;
	openStringCount = 0;
	landingCount = 0; //for extending section landing on open strings
	sectionCount = 0;

	res = []; //notes before the more static repetitions are put in

	//~~~~run routine and create template sequence
	({sectionCount < 4}).while({
		var alterPattern;

		//alter string pattern or not
		alterPattern = [true, false].wchoose([1, 2].normalizeSum);
		if(alterPattern, {
			strings = (0..5).scramble[..(4.rand + 1)];
			//rotate if a note gets repeated
			if(lastStrings.last == strings.first, {strings = strings.rotate});
			//stringIndex = 0;
			lastStrings = strings;
		});

		//iterate through the strings
		strings.do({arg string, stringIndex;
			var alterPos;

			//alter state or not favoring off if on (determines if string is open or fretted)
			if(sectionCount.even, {
				var isFretted, probs, alterState;
				isFretted = (state[string] == 1);
				probs = [if(isFretted, {2}, {1}), 1].normalizeSum;
				alterState = [true, false].wchoose(probs);
				if(alterState, {state[string] = (state[string] + 1) % 2});
			});

			//alternate option
			if(sectionCount.odd, {
				var isFretted, alterable;
				isFretted = (state[string] == 1);
				alterable = isFretted || ((state[string] == 0) && (state.sum < 3));
				if(alterable, {
					var probs, alterState;
					probs = [if(isFretted, {1}, {2}), 1].normalizeSum;
					alterState = [true, false].wchoose(probs);
					if(alterState, {state[string] = (state[string] + 1) % 2});
				});
			});

			//alter fret if fretted and keeping hand in similar position
			alterPos = (position[string] * state[string]) > 0;
			alterPos = alterPos && (state[string] == 1); //isFretted
			alterPos = alterPos && (position[string] > (position.maxItem - 3));
			alterPos = [alterPos, false].wchoose([7, 1].normalizeSum);
			if(alterPos, {
				var walkDown, stepLimit;
				//walk down or not
				//BUG - GETTING REPEATED NOTES HERE!!!!
				walkDown = [true, false].wchoose([1, 2].normalizeSum);
				if(walkDown, {
					res = res.add([string, state[string] * position[string], dur, position.deepCopy]);
				});

				//make sure a hand position is not too wide
				stepLimit = (position.maxItem - (position[string] - 2)) != 4;
				if(stepLimit.not, {
					position[string] = (position[string] - 1).clip(0, 12);
				});
				if(stepLimit, {
					position[string] = (position[string] - [1, 2].choose).clip(0, 12);
				});
			});

			//alter duration or not
			if([true, false].wchoose([3, 1].normalizeSum), {dur = setDur.value});

			//add
			res = res.add([string, state[string] * position[string], dur, position.deepCopy]);

			//reset if everything arrives at the bottom string
			//perhaps erase the extranotes here!
			if((position[string] * state[string]) == 0, {openStringCount = openStringCount + 1}, {openStringCount = 0});
			if(position == [0, 0, 0, 0, 0, 0], {
				var hasLanded;
				hasLanded = (openStringCount > 20) && (stringIndex == (strings.size - 1));
				if(hasLanded, {
					position = 6.collect({10 + 3.rand});
					landingCount = 0;
					sectionCount = sectionCount + 1;
					(openStringCount - 1).do({arg index;
						res[res.size - index - 1][3] = [0, 0, 0, 0, 0, 0];
						res[res.size - index - 1][2] = (dur * (1 + ((1 - (index / openStringCount).clip(0, 1).pow(0.25)) * 10))).asInteger
					});
				});
				if(hasLanded.not, {landingCount = landingCount + 1})
			});
		})
	});
	res
};


//~~~~insert more static sections by repeating a figure
finalizeSeqs = {arg initSeq;
	var extendToBeat, insertTS,
	timeStampSection, timeStampTotal, timeStampSectionStart, lastDur, lastPos,
	sectionSeq, timeSigInsSeq, sectionPosLimit, state, guitarSeq;

	extendToBeat = {arg seq, round = 4;
		var timeStampTotal, altEndDur;
		// this makes sure it is some multiple of a beat
		timeStampTotal = seq.slice(nil, 2).sum;
		altEndDur = timeStampTotal.round(round) - timeStampTotal;
		//if(altEndDur < 0, {altEndDur = altEndDur + round});
		seq.last[2] = seq.last[2] + altEndDur;
		if(altEndDur < 0, {seq.last[2]});
		[seq, altEndDur];
	};

	insertTS = {arg seq, timeStampSectionStart, type, accompSwitch;
		var timeStampTotal, noMeasures;
		timeStampTotal = seq.slice(nil, 2).sum;
		sectionSeq = sectionSeq.add([timeStampTotal, type, accompSwitch]);
		noMeasures = ((timeStampTotal - timeStampSectionStart) / 16);
		if(noMeasures.frac > 0, {
			timeSigInsSeq = timeSigInsSeq.add(
				// make 5/4 instrad of 1/4
				if((noMeasures.frac / 0.25).asInteger != 2, {
					[timeStampTotal - (4 * (noMeasures.frac / 0.25).asInteger),(noMeasures.frac / 0.25).asInteger]
				}, {
					[timeStampTotal - (4 * 6), 6]
				});
			);
			timeSigInsSeq = timeSigInsSeq.add([timeStampTotal, 4]);
		});
	};

	timeStampSection = 0; //track time in each section
	timeStampTotal = 0; //track overall time
	timeStampSectionStart = 0; //track the time of the start of a section
	lastDur = initSeq[0][2]; //helper for time signature data
	lastPos = initSeq[0].last; //helper for keeping track of landing.

	guitarSeq = []; //this is the final sequence with repetitions inserted
	sectionSeq = [[0, 0, true]]; //sequence of times for each section (used for double bars in score)
	timeSigInsSeq = [[0, 4]]; //sequence for insertion of time signatures and double bars;

	sectionPosLimit = 3 + 6.rand;
	state = 0;

	initSeq.do({arg item, index, altEndDur;
		var dur, pos;
		dur = item[2];
		pos = item.last;

		if(state != 1, {
			// basically this just copies the original template over
			var landingBorder, sectionBorder;
			landingBorder = (pos == [0, 0, 0, 0, 0, 0]) && (lastPos != [0, 0, 0, 0, 0, 0]);
			sectionBorder = (pos != [0, 0, 0, 0, 0, 0]) && (lastPos == [0, 0, 0, 0, 0, 0]);
			if(landingBorder || sectionBorder, {
				var seqExtPair;
				seqExtPair = extendToBeat.value(guitarSeq, 8);
				guitarSeq = seqExtPair[0];
				timeStampSection = timeStampSection + seqExtPair[1];
				insertTS.value(guitarSeq, timeStampSectionStart, if(pos == [0, 0, 0, 0, 0, 0], {1}, {-1}), false);
				timeStampSectionStart = guitarSeq.slice(nil, 2).sum;
			});

			if(sectionBorder, {
				state = 0;
				sectionPosLimit = 3 + 6.rand;
			});

			guitarSeq = guitarSeq.add(item.add(-1));
			timeStampSection = timeStampSection + dur;

			lastDur = dur;
			lastPos = pos;

			if((state == 0) && (pos.minItem < sectionPosLimit), {state = 1});
		});

		if(state == 1, {
			// grabs a figure and repeats it altering it subtly
			var rec, reps, noMeasures;

			guitarSeq = extendToBeat.value(guitarSeq, 8)[0];
			timeStampTotal = guitarSeq.slice(nil, 2).sum;
			insertTS.value(guitarSeq, timeStampSectionStart, 0, true);
			timeStampSectionStart = timeStampTotal;
			//sectionSeq = sectionSeq.add([timeStampTotal, 0, true]);
			rec = guitarSeq[(guitarSeq.size - (10.rand + 5))..guitarSeq.size].deepCopy;
			reps = 5.rand + 5;
			reps.do({arg index;
				rec.do({arg item, rIndex;
					var add, dur;
					add = if(index == 0, {3}, {0});
					dur = (item[2] + 2.rand2 + add);
					if(dur < 2, {dur = [0, 2].wchoose([1, 4].normalizeSum)});
					rec[rIndex] = [item[0], item[1], dur];
					if([true, false].wchoose([5, 1].normalizeSum), {
						guitarSeq = guitarSeq.add(rec[rIndex].add((1 / reps) * index));
						//timeStampTotal = timeStampTotal + dur;
					});

					// if chord randomly choose one of the notes
					if(guitarSeq.last[2] == 0, {
						arg toAdd = [];
						//guitarSeq[(guitarSeq.size - 3)..].postln;
						toAdd = toAdd.add(guitarSeq.pop);
						toAdd = toAdd.add(guitarSeq.pop);
						toAdd[0][2] = toAdd[1][2];
						toAdd[1][3] = toAdd[0][3];
						//toAdd.postln;
						toAdd = toAdd.choose;
						guitarSeq = guitarSeq.add(toAdd);
						//guitarSeq[(guitarSeq.size - 2)..].postln
					});
				});

				if(index < (reps - 1), {
					guitarSeq = extendToBeat.value(guitarSeq, 4)[0];
				}, {
					guitarSeq = extendToBeat.value(guitarSeq, 8)[0];
				});

			});

			insertTS.value(guitarSeq, timeStampSectionStart, 0, true);

			timeStampSection = 0;
			timeStampSectionStart = guitarSeq.slice(nil, 2).sum;
			lastDur = initSeq[index + 1][2];
			state = 2;
		});
	});
	[guitarSeq, sectionSeq, timeSigInsSeq]
};

// add the high note part
// !!! CHECK - THE LENGTHS OF THESE MIGHT HAVE BEEN UNINTENTIONALLY DOUBLED - !!!
finalizeAccompHigh = {arg sectionSeq;
	var accompHighSeq, timeStamp, secType;
	accompHighSeq = [];
	timeStamp = 0;
	secType = 0;

	sectionSeq.do({arg secData;
		var secEnd, freq, noRestCount, shortCount;
		secEnd = secData[0];
		freq = if(secType == 0, {62.midicps * 8},  {62.midicps * 8 * 6/5});
		if(secData.last, {secType = ((secType + 1) % 2)});
		noRestCount = 0;
		shortCount = 0;
		while({timeStamp < secEnd}, {
			var dur, sus, isShort, insertRest;

			isShort = case
			{shortCount == 0} {true}
			{shortCount < 3} {[true, false].wchoose([2, 1].normalizeSum)}
			{true} {false};

			insertRest = [true, noRestCount > 3].wchoose([1, 1].normalizeSum);

			if(isShort, {
				sus = (20.rand + 20).round(2);
				shortCount = shortCount + 1;
			}, {
				sus = (62.rand + 50).round(2);
				shortCount = 0;
			});

			if(insertRest, {
				dur = sus + (20.rand + 20).round(2);
				noRestCount = 0;
			}, {
				dur = sus + 2;
				noRestCount = noRestCount + 1;
			});

			if((timeStamp + dur) < secEnd, {
				accompHighSeq = accompHighSeq.add([freq, dur, sus.clip(0, dur)]);
			}, {
				dur = ((secEnd - timeStamp) + 38.rand).clip(2, 1000).round(2);
				accompHighSeq = accompHighSeq.add([freq, dur, 0]);
			});
			timeStamp = timeStamp + dur;
		});
	});
	accompHighSeq
};


// add the low note part
finalizeAccompLow = {arg guitarSeq, sectionSeq;
	var accompLowSeq, durAccum, lastTrigVal;
	accompLowSeq = [];
	durAccum = 0;
	lastTrigVal = 0;
	guitarSeq.do({arg item, i;
		var dur, trig, freq1, freq2, finalDur;
		dur = item[2];
		trig = item.last;
		if(lastTrigVal != trig, {
			freq1 = if(trig > -1, {62.midicps / 4 * 3/4}, {62.midicps / 4});
			freq2 = freq1 + if(trig > -1, {(5 * (1-trig))}, {0});
			finalDur = durAccum;
			accompLowSeq = accompLowSeq.add([freq1, freq2, finalDur]);
			durAccum = 0;
		});
		durAccum = durAccum + dur;
		lastTrigVal = trig;
	});

	accompLowSeq = [accompLowSeq.slice(nil, 0), accompLowSeq.slice(nil, 1), accompLowSeq.slice(nil, 2).integrate].flop;
	sectionSeq.collect({arg section;
		if(section[1] == 1, {
			var curTime = section[0];
			accompLowSeq = accompLowSeq.add([62.midicps / 8, (62.midicps / 8) + 0, curTime]);
			curTime = curTime - (50.rand + 50).round(4).asInteger;
			accompLowSeq = accompLowSeq.add([64.midicps / 8, (64.midicps / 8) + 2, curTime]);
			curTime = curTime - (50.rand + 50).round(4).asInteger;
			accompLowSeq = accompLowSeq.add([65.midicps / 8, (65.midicps / 8) + 4, curTime]);
		});
		if(section[1] == -1, {
			var curTime = section[0];
			accompLowSeq = accompLowSeq.add([62.midicps / 4, (62.midicps / 4) + 0, curTime]);
		});
	});

	accompLowSeq = accompLowSeq.sort({ arg a, b; a[2] < b[2] });
	accompLowSeq = [accompLowSeq.slice(nil, 0), accompLowSeq.slice(nil, 1),
		accompLowSeq.slice(nil, 2).differentiate.drop(1).add(1)].flop;

	//accompLowSeq = [accompLowSeq.slice(nil, 0), accompLowSeq.slice(nil, 1),accompLowSeq.slice(nil, 2).drop(1).add(1)].flop;

	accompLowSeq
};

~genMusicData = {
	var initSeq, finalSeqs, guitarSeq, accompHighSeq, accompLowSeq, sectionSeq, timeSigSeq,
	patterns, scoreData, sectionOffsets;

	initSeq = genInitSeq.value;
	finalSeqs = finalizeSeqs.value(initSeq);
	guitarSeq = finalSeqs[0];
	accompHighSeq = finalizeAccompHigh.value(finalSeqs[1]);
	accompLowSeq = finalizeAccompLow.value(finalSeqs[0], finalSeqs[1]);
	sectionSeq = finalSeqs[1];
	timeSigSeq = finalSeqs[2];

	patterns = ~genPatterns.value(guitarSeq, accompLowSeq, accompHighSeq, sectionSeq);
	scoreData =  ~genScoreData.value(guitarSeq, accompLowSeq, accompHighSeq, timeSigSeq, sectionSeq);
	sectionOffsets = sectionSeq.slice(nil, 0);

	[patterns, scoreData, sectionOffsets]
};
)


/*
~player[0].play;

(
~player = EventPatternProxy.new;
~faderPattern = Pmono(
			\crossFade,
			\sel, Pseq([0, 1], ~sectionOffsets / 2),
			\dur, Pseq(~sectionOffsets.differentiate.drop(1) * 0.08),
			\busA, ~busA.index,
			\busB, ~busB.index
	);
~fader = Synth(\crossFade, [\sel, 0, \busA, ~busA.index, \busB, ~busB.index]);
~player.source = Ptpar(
	([~sectionOffsets.postln * 0.08, ~patterns].flop.flat ++ [0, ~faderPattern]).postln
);
)
~fader.play
~player.play
(
~fader.set(\sel, 1);
~patterns[3].play
)

~fader = Synth(\crossFade, [\sel, 1, \busA, ~busA.index, \busB, ~busB.index]);
(
~patterns[3].play;
~testDrone = Synth.new(\droneOut, [\gate, 1, \bus, ~droneBus.index]);
//~testDrone.set(\gate, 0);
~dronePattern.play
)


(
~player.source = Ptpar([~sectionOffsets.postln * 0.08,
	~patterns.collect({arg pt, i;
		if(i < (~patterns.size - 1), {
			PfadeOut(pt, 0.1, (~sectionOffsets.differentiate.drop(1)[i] * 0.08) - 0.1)
		}, {
			pt
		})
})].flop.flat.postln);
)
~sectionOffsets.differentiate.postln;
~player.play
PfadeOut(~patterns[2], 0.1, (~sectionOffsets.differentiate.drop(1)[2] * 0.08) - 0.1).play
PfadeOut(~player[0]).play;
Pdef(\play, ~player[0]).play;
Pdef(\play, ~player[1])
~player[2].play;
~player.pause;


(
var durUnit = 0.15;

SynthDef(\machine, {arg freq, gate = 1, sustain, amp;
	var sound;
	sound = TWChoose.ar(Impulse.kr(0), [
		PinkNoise.ar(EnvGen.kr(Env.perc(0.01, sustain, amp * 10), gate, doneAction: 2)),
		BrownNoise.ar(EnvGen.kr(Env.perc(0.01, sustain, amp * 2), gate, doneAction: 2))
	], [0, 20], 1);
	Out.ar([0, 1], sound)
}).add;

~machine1 = Pbind(
	\instrument, \machine,
	\amp, Pseq(300.collect({var rand = [0.03, 0].choose; (20.rand + 10).rand.collect({rand})}).flat),
	\dur, Pseq(1000.collect({[durUnit, durUnit + (durUnit / 100).rand2].wchoose([10, 1].normalizeSum)}).flat),
	\sustain, Pseq(1000.collect({durUnit * (1.75 + 0.5.rand)})),//2.25].wchoose([1, 20].normalizeSum)})),
	\freq, Pseq(1000.collect({[[300, 250], [300, 250].choose].wchoose([10, 1].normalizeSum)}).flat / 2)
).play;
)

~machine1.play;
~machine1.stop;


(
var durUnit = 0.02;
b = Bus.audio(s, 1);

SynthDef(\test, { arg out=0, freq=440, amp=0.1, pan=0, gate=1;
	var z;
	z = LPF.ar(
		Mix.new(VarSaw.ar(freq + [0, Rand(-0.4,0.0), Rand(0.0,0.4)], 0, 0.3, 0.3)),
		XLine.kr(Rand(4000,5000), Rand(2500,3200), 1)
	) * Linen.kr(gate, 0.01, 0.7, 0.3, 2);
	Out.ar(b, Pan2.ar(z, pan, amp));
}, [\ir]).add;

SynthDef(\defaultBus, {arg gate;
	Out.ar([0, 1], Clip.ar(In.ar(b, 1), -1, 1) * 0.25 * EnvGen.ar(Env.asr(20, 1, 20), gate))
}
).add;

Pbind(
	\instrument, \test,
	\amp, 0.5,
	\dur, durUnit,
	\sustain, 0.05,
	\freq, Pseq(3000.collect({[[62.midicps, 250], [62.midicps, 250].choose].wchoose([10, 1].normalizeSum)}).flat / 2)
).play;

~testDrone = Synth.new(\defaultBus, [\gate, 1]);
)

~testDrone.set(\gate, 0);


(
var durUnit = 0.02;
b = Bus.audio(s, 1);

SynthDef(\test, { arg out=0, freq=440, amp=0.1, pan=0, gate=1;
	var z;
	z = LPF.ar(
		Mix.new(VarSaw.ar(freq + [0, Rand(-0.4,0.0), Rand(0.0,0.4)], 0, 0.3, 0.3)),
		XLine.kr(Rand(4000,5000), Rand(2500,3200), 1)
	) * Linen.kr(gate, 0.01, 0.7, 0.3, 2);
	Out.ar(b, Pan2.ar(z, pan, amp));
}, [\ir]).add;

SynthDef(\defaultBus, {
	Out.ar([0, 1], Clip.ar(In.ar(b, 1), -1, 1) * 0.25)
}
).add;

Pbind(
	\instrument, \test,
	\amp, Pseq(3000.collect({arg i; (i / 3000).clip(0, 1) * 0.5})),
	\dur, durUnit,
	\sustain, 0.05,
	\freq, Pseq(3000.collect({[[62.midicps, 250], [62.midicps, 250].choose].wchoose([10, 1].normalizeSum)}).flat / 2)
).play;

Synth.new(\defaultBus)
)


(
var durUnit = 0.15;

SynthDef(\machine, {arg freq, gate = 1, sustain, amp;
	var sound;
	sound = TWChoose.ar(Impulse.kr(0), [
		PinkNoise.ar(EnvGen.kr(Env.perc(0.01, sustain, amp * 10), gate, doneAction: 2)),
		BrownNoise.ar(EnvGen.kr(Env.perc(0.01, sustain, amp * 2), gate, doneAction: 2))
	], [0, 20], 1);
	Out.ar([0, 1], sound)
}).add;

~machine1 = Pseq(
	10.collect({
		var randL, randLArray, amp, durUnitSMult, durUnitSMultLimit, hitsToClip;
		randL = 30.rand + 30;
		randLArray = (0..randL) ++  (0..(randL-1)).reverse;
		amp = [0.1, 0].wchoose([2, 1].normalizeSum);
		durUnitSMult = 2 + 1.0.rand;
		durUnitSMultLimit = (durUnitSMult - 1) + 0.5.rand;
		hitsToClip = 3 + 3.rand;

		Pseq([Pbind(
			\instrument, \machine,
			\amp, 0.1,
			\dur, Pseq(randLArray.collect({arg i; durUnit * (durUnitSMult - ((i / hitsToClip).clip(0, durUnitSMultLimit)))})),
			\sustain, Pseq(randLArray.size.collect({durUnit * (1.75 + 0.5.rand)})),//2.25].wchoose([1, 20].normalizeSum)})),
			\freq, Pseq(randLArray.size.collect({[[300, 250], [300, 250].choose].wchoose([10, 1].normalizeSum)}).flat / 2)
		),Rest(3.rand + 5)
		])
	}), inf
).play;
)

62.midicps

*/